# Конфигурация

Конфигруация MockGUI представлена одним файлом `config.ini` расположенном в корне проекта.

## Пример файла конфигруации

```ini
[server]
port = 8081
db = "sqlite://db/workbase.sqlite3"

[repo]
repo = "repo"

[projects]
path = "projects"
old = 3

[counter]
path = "locks/counter"

[configs]
hide=open,amazon,anolis,circle,custom,euro,fedora,mageia,navy,alma,rocky
selected=msvsphere

[pages]
items_per_page = 30

[sign]
path = "keys"

[repoview]
path = "repoview"
```

## Секции

Все пути указываются от корня проекта.

### server 

* `port` - порт, который будет слущать сервер для доступа к WEB интерфейсу (умолчание: 8081)
* `db` - путь к базе данных и тип базы данных (умолчание: db/workbase.sqlite3 и тип базы данных SQLite)

### repo

* `repo` - путь к каталогу, где гранятся bare git проекты, можно скопировать уже существующие, они автоматом при старте добавятся в базу (умолчание: repo)
  
### counter

* `path` - путь к глобальному счетчику сборок (умолчание: locks/counter)

### projects

* `path` - путь к папке, где создаются проекты, в нее же копируются git исходники, поэтому рекомендуется эту папку делать пообъемнее (умолчание: projects)
* `old` - неиспользуемый параметр

### configs

* `hide` - скрыть из списка доступных конфигураций сборки считанных из `/etc/mock/`, содержащие в имени одно из слов, указееых через запятую 
* `selected` - добавить в список избранных сборки с именами, указанными содержащими слова через запятую

### pages

* `items_per_page` - отображать на страницах не более указанного числа записей (умолчание: 30)

### sign

* `path` - папка, где хранятся gpg ключи (приватный и публичный) для подписи пакетов (умолчание: keys)

### repoview

* `path` - папка, где хранятся шаблоны для генерации статического repoview для подписанного репозитория (умолчание: repoview)

Так же следует учесть, что сборки происходят в папке `/var/lib/mock` поэтому данная папка так же должна быть большого объема.